local CF=CreateFrame("Frame")
CF:RegisterEvent("PLAYER_LOGIN")
CF:SetScript("OnEvent", function(self, event)

if SUILDB.UNITFRAMES == true then 		

local PlayerUnitFrame = CreateFrame('Frame', nil, UIParent);  
local TargetUnitFrame = CreateFrame('Frame', nil, UIParent); 

-- Textur
local function SetTextures()

	for _, StatusBarTextures in pairs ({
		PlayerFrameHealthBar, PlayerFrameManaBar,
		TargetFrameHealthBar, TargetFrameManaBar,
		TargetFrameToTHealthBar, TargetFrameToTManaBar,
		FocusFrameHealthBar, FocusFrameManaBar,
		FocusFrameToTHealthBar, FocusFrameToTManaBar,
		PartyMemberFrame1HealthBar,
		PartyMemberFrame2HealthBar,
		PartyMemberFrame3HealthBar,
		PartyMemberFrame4HealthBar,
		PartyMemberFrame1ManaBar,
		PartyMemberFrame2ManaBar,
		PartyMemberFrame3ManaBar,
		PartyMemberFrame4ManaBar,
		CastingBarFrame, TargetFrameSpellBar, FocusFrameSpellBar,	
		}) 	do
			StatusBarTextures:SetStatusBarTexture("Interface\\Addons\\SUILite\\inc\\media\\unitframes\\UI-StatusBar")
		end

end

-- Player
local function StylePlayerFrame()
	SetTextures()
	PlayerName:Hide();
	PlayerFrameGroupIndicatorText:ClearAllPoints();
	PlayerFrameGroupIndicatorText:SetPoint("BOTTOMLEFT", PlayerFrame,"TOP",0,-20);
	PlayerFrameGroupIndicatorLeft:Hide();
	PlayerFrameGroupIndicatorMiddle:Hide();
	PlayerFrameGroupIndicatorRight:Hide();
	PlayerFrameHealthBar:SetPoint("TOPLEFT",106,-24);
	PlayerFrameHealthBar:SetHeight(26);
	PlayerFrameHealthBar.LeftText:ClearAllPoints();
	PlayerFrameHealthBar.LeftText:SetPoint("LEFT",PlayerFrameHealthBar,"LEFT",10,0);	
	PlayerFrameHealthBar.RightText:ClearAllPoints();
	PlayerFrameHealthBar.RightText:SetPoint("RIGHT",PlayerFrameHealthBar,"RIGHT",-5,0);
	PlayerFrameHealthBarText:SetPoint("CENTER", PlayerFrameHealthBar, "CENTER", 0, 0);
	PlayerFrameManaBar:SetPoint("TOPLEFT",106,-52);
	PlayerFrameManaBar:SetHeight(13);
	PlayerFrameManaBar.LeftText:ClearAllPoints();
	PlayerFrameManaBar.LeftText:SetPoint("LEFT",PlayerFrameManaBar,"LEFT",10,0)		;
	PlayerFrameManaBar.RightText:ClearAllPoints();
	PlayerFrameManaBar.RightText:SetPoint("RIGHT",PlayerFrameManaBar,"RIGHT",-5,1);
	PlayerFrameManaBarText:SetPoint("CENTER",PlayerFrameManaBar,"CENTER",0,0);
	PlayerFrameManaBar.FeedbackFrame:ClearAllPoints();
	PlayerFrameManaBar.FeedbackFrame:SetPoint("CENTER",PlayerFrameManaBar,"CENTER",0,0);
	PlayerFrameManaBar.FeedbackFrame:SetHeight(13);
	PlayerFrameManaBar.FullPowerFrame.SpikeFrame.AlertSpikeStay:ClearAllPoints();
	PlayerFrameManaBar.FullPowerFrame.SpikeFrame.AlertSpikeStay:SetPoint("CENTER", PlayerFrameManaBar.FullPowerFrame, "RIGHT", -6, -3);
	PlayerFrameManaBar.FullPowerFrame.SpikeFrame.AlertSpikeStay:SetSize(30,29);
	PlayerFrameManaBar.FullPowerFrame.PulseFrame:ClearAllPoints();
	PlayerFrameManaBar.FullPowerFrame.PulseFrame:SetPoint("CENTER", PlayerFrameManaBar.FullPowerFrame,"CENTER",-6,-2);
	PlayerFrameManaBar.FullPowerFrame.SpikeFrame.BigSpikeGlow:ClearAllPoints();
	PlayerFrameManaBar.FullPowerFrame.SpikeFrame.BigSpikeGlow:SetPoint("CENTER",PlayerFrameManaBar.FullPowerFrame,"RIGHT",5,-4);
	PlayerFrameManaBar.FullPowerFrame.SpikeFrame.BigSpikeGlow:SetSize(30,50);
    PlayerFrameTexture:SetTexture('Interface\\Addons\\SUILite\\inc\\media\\unitframes\\UI-TargetingFrame');
	PlayerStatusTexture:SetTexture('Interface\\Addons\\SUILite\\inc\\media\\unitframes\\UI-Player-Status');

end

-- Target
local function StyleTargetFrame()
	SetTextures()
	local unitClassification = UnitClassification(TargetFrame.unit);
	
    TargetFrame.healthbar:SetHeight(29);
    TargetFrame.healthbar:SetPoint('TOPLEFT',7,-22);
    TargetFrame.healthbar.TextString:SetPoint('CENTER',-50,6);
    TargetFrame.deadText:SetPoint('CENTER',-50,6);
    TargetFrame.nameBackground:Hide();
    TargetFrame.Background:SetPoint('TOPLEFT',7,-22);

	TargetFrame.deadText:ClearAllPoints();
	TargetFrame.deadText:SetPoint("CENTER", TargetFrame.healthbar, "CENTER",0,0);
	TargetFrame.nameBackground:Hide();
	TargetFrame.Background:SetSize(119,42);

	TargetFrame.manabar.pauseUpdates = false;
	TargetFrame.manabar:Show();
	TextStatusBar_UpdateTextString(TargetFrame.manabar);
	TargetFrame.threatIndicator:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Flash");

	TargetFrame.name:SetPoint("LEFT", TargetFrame, 15, 36);
	TargetFrame.healthbar:SetSize(119, 26);
	TargetFrame.healthbar:ClearAllPoints();
	TargetFrame.healthbar:SetPoint("TOPLEFT", 5, -24);
	
	TargetFrame.healthbar.LeftText:ClearAllPoints();
	TargetFrame.healthbar.LeftText:SetPoint("LEFT", TargetFrame.healthbar, "LEFT", 8, 0);
	TargetFrame.healthbar.RightText:ClearAllPoints();
	TargetFrame.healthbar.RightText:SetPoint("RIGHT", TargetFrame.healthbar, "RIGHT", -5, 0);
	TargetFrame.healthbar.TextString:SetPoint("CENTER", TargetFrame.healthbar, "CENTER", 0, 0);
		
	TargetFrame.manabar:ClearAllPoints();
	TargetFrame.manabar:SetPoint("TOPLEFT", 5, -52);
	TargetFrame.manabar:SetSize(119, 13);
		
	TargetFrame.manabar.LeftText:ClearAllPoints();
	TargetFrame.manabar.LeftText:SetPoint("LEFT", TargetFrame.manabar, "LEFT", 8, 0);	
	TargetFrame.manabar.RightText:ClearAllPoints();
	TargetFrame.manabar.RightText:SetPoint("RIGHT", TargetFrame.manabar, "RIGHT", -5, 0);
	TargetFrame.manabar.TextString:SetPoint("CENTER", TargetFrame.manabar, "CENTER", 0, 0);

    local frameTexture;
    if ( unitClassification == 'worldboss' or unitClassification == 'elite' ) then
		frameTexture = 'Interface\\Addons\\SUILite\\inc\\media\\unitframes\\UI-TargetingFrame-Elite';
	elseif ( unitClassification == 'rareelite' ) then
		frameTexture = 'Interface\\Addons\\SUILite\\inc\\media\\unitframes\\UI-TargetingFrame-Rare-Elite';
	elseif ( unitClassification == 'rare' ) then
        frameTexture = 'Interface\\Addons\\SUILite\\inc\\media\\unitframes\\UI-TargetingFrame-Rare';
    else
        frameTexture = 'Interface\\Addons\\SUILite\\inc\\media\\unitframes\\UI-TargetingFrame';
	end

	TargetFrame.borderTexture:SetTexture(frameTexture);
	
end

--TargetOfTarget
TargetFrameToTHealthBar:ClearAllPoints()
TargetFrameToTHealthBar:SetPoint("TOPLEFT", 44, -15)
TargetFrameToTHealthBar:SetHeight(10)
TargetFrameToTManaBar:ClearAllPoints()
TargetFrameToTManaBar:SetPoint("TOPLEFT", 44, -25)
TargetFrameToTManaBar:SetHeight(5)
FocusFrameToTHealthBar:ClearAllPoints()
FocusFrameToTHealthBar:SetPoint("TOPLEFT", 45, -15)
FocusFrameToTHealthBar:SetHeight(10)
FocusFrameToTManaBar:ClearAllPoints()
FocusFrameToTManaBar:SetPoint("TOPLEFT", 45, -25)
FocusFrameToTManaBar:SetHeight(5)
FocusFrameToT.deadText:SetWidth(0.01)

--PET	
PetFrameHealthBar:ClearAllPoints()
PetFrameHealthBar:SetPoint("TOPLEFT", 45, -22)
PetFrameHealthBar:SetHeight(10)
PetFrameManaBar:ClearAllPoints()
PetFrameManaBar:SetPoint("TOPLEFT", 45, -32)
PetFrameManaBar:SetHeight(5)

local function HandleEvents (self, event, ...)
    if (event == 'PLAYER_ENTERING_WORLD') then
		StylePlayerFrame();
		StyleTargetFrame();
	end
	
    if (event == 'UNIT_EXITED_VEHICLE' and ... == 'player') then
		StylePlayerFrame();
		StyleTargetFrame();
    end
end

-- Register the Modules Events
PlayerUnitFrame:SetScript('OnEvent', HandleEvents);
PlayerUnitFrame:RegisterEvent('PLAYER_ENTERING_WORLD');
PlayerUnitFrame:RegisterEvent('UNIT_HEALTH');
PlayerUnitFrame:RegisterEvent('PLAYER_TARGET_CHANGED');
PlayerUnitFrame:RegisterEvent('UNIT_EXITED_VEHICLE');

-- Hook a bunch of Blizzard functions
hooksecurefunc('TargetFrame_CheckDead', StyleTargetFrame);
hooksecurefunc('TargetFrame_Update', StyleTargetFrame);
hooksecurefunc('TargetFrame_CheckFaction', StyleTargetFrame);
hooksecurefunc('TargetFrame_CheckClassification', StyleTargetFrame);
hooksecurefunc('TargetofTarget_Update', StyleTargetFrame);

hooksecurefunc('UnitFrameHealthBar_Update', function(self)
	StylePlayerFrame();
	StyleTargetFrame();
	if UnitIsPlayer(self.unit) then
		local c = RAID_CLASS_COLORS[select(2,UnitClass(self.unit))];
		if c then
			self:SetStatusBarColor(c.r, c.g, c.b)
		end
	end
end)

hooksecurefunc("UnitFrameManaBar_UpdateType", function(manaBar)
	PlayerFrameManaBar:SetStatusBarTexture('Interface\\Addons\\SUILite\\inc\\media\\unitframes\\UI-StatusBar');
	TargetFrameManaBar:SetStatusBarTexture('Interface\\Addons\\SUILite\\inc\\media\\unitframes\\UI-StatusBar');
 end)

hooksecurefunc('HealthBar_OnValueChanged', function(self)
	StylePlayerFrame();
	StyleTargetFrame();
	if UnitIsPlayer(self.unit) then
		local c = RAID_CLASS_COLORS[select(2,UnitClass(self.unit))];
		if c then
			self:SetStatusBarColor(c.r, c.g, c.b)
		end
	end
end)

hooksecurefunc("PlayerFrame_UpdateStatus", function()
   if IsResting("player") then
      PlayerStatusTexture:Hide()
      PlayerRestGlow:Hide()
      PlayerStatusGlow:Hide()
   end
end)

else

hooksecurefunc("HealthBar_OnValueChanged", function (self)
	if UnitIsPlayer(self.unit) then
		local c = RAID_CLASS_COLORS[select(2,UnitClass(self.unit))];
		if c then
			self:SetStatusBarColor(c.r, c.g, c.b)
		end
	end
end);

hooksecurefunc("UnitFrameHealthBar_Update", function (self)
	if UnitIsPlayer(self.unit) then
		local c = RAID_CLASS_COLORS[select(2,UnitClass(self.unit))];
		if c then
			self:SetStatusBarColor(c.r, c.g, c.b)
		end
	end
end);

hooksecurefunc('TargetFrame_CheckFaction', function(self)
  if ( not UnitPlayerControlled(self.unit)
  and  UnitIsTapDenied(self.unit)) then
    self.nameBackground:SetVertexColor(0.0, 0.0, 0.0, 0.5);
    if ( self.portrait ) then
      self.portrait:SetVertexColor(0.5, 0.5, 0.5);
    end
  else
    self.nameBackground:SetVertexColor(0.0, 0.0, 0.0, 0.5);
    if ( self.portrait ) then
      self.portrait:SetVertexColor(1.0, 1.0, 1.0);
    end
  end
end)

end

-- Hide
hooksecurefunc("PlayerFrame_UpdateStatus",function()
	PlayerStatusTexture:Hide()
	PlayerRestGlow:Hide()
    PlayerStatusGlow:Hide()
    PlayerPrestigeBadge:SetAlpha(0)
    PlayerPrestigePortrait:SetAlpha(0)
    TargetFrameTextureFramePrestigeBadge:SetAlpha(0)
    TargetFrameTextureFramePrestigePortrait:SetAlpha(0)
    FocusFrameTextureFramePrestigeBadge:SetAlpha(0)
    FocusFrameTextureFramePrestigePortrait:SetAlpha(0)
end)

-- Spellsteal Border
hooksecurefunc("TargetFrame_UpdateAuras", function(s)
	for i = 1, MAX_TARGET_BUFFS do
			_, _, ic, _, dT = UnitBuff(s.unit, i)
			if(ic and (not s.maxBuffs or i<=s.maxBuffs)) then
					fS=_G[s:GetName()..'Buff'..i..'Stealable']
					if(UnitIsEnemy(PlayerFrame.unit, s.unit) and dT=='Magic') then
							fS:Show()
					else
							fS:Hide()
					end
			end
	end
end)

-- BUFFS
local unit = {}
local AURA_START_X = 5;
local AURA_START_Y = 28;
local AURA_OFFSET_Y = 3;
local LARGE_AURA_SIZE = 27
local SMALL_AURA_SIZE = 25
local AURA_ROW_WIDTH = 122;

function unit:targetUpdateAuraPositions(self, auraName, numAuras, numOppositeAuras, largeAuraList, updateFunc, maxRowWidth, offsetX, mirrorAurasVertically)
	local size
	local offsetY = AURA_OFFSET_Y
	local rowWidth = 0
	local firstBuffOnRow = 1
	for i=1, numAuras do
		if ( largeAuraList[i] ) then
			size = LARGE_AURA_SIZE
			offsetY = AURA_OFFSET_Y + AURA_OFFSET_Y
		else
			size = SMALL_AURA_SIZE
		end
		if ( i == 1 ) then
			rowWidth = size
			self.auraRows = self.auraRows + 1
		else
			rowWidth = rowWidth + size + offsetX
		end
		if ( rowWidth > maxRowWidth ) then
			updateFunc(self, auraName, i, numOppositeAuras, firstBuffOnRow, size, offsetX, offsetY, mirrorAurasVertically)
			rowWidth = size
			self.auraRows = self.auraRows + 1
			firstBuffOnRow = i
			offsetY = AURA_OFFSET_Y
		else
			updateFunc(self, auraName, i, numOppositeAuras, i - 1, size, offsetX, offsetY, mirrorAurasVertically)
		end
	end
end

local function unit_targetUpdateAuraPositions(self, auraName, numAuras, numOppositeAuras, largeAuraList, updateFunc, maxRowWidth, offsetX, mirrorAurasVertically)
unit:targetUpdateAuraPositions(self, auraName, numAuras, numOppositeAuras, largeAuraList, updateFunc, maxRowWidth, offsetX, mirrorAurasVertically)
end
hooksecurefunc("TargetFrame_UpdateAuraPositions", unit_targetUpdateAuraPositions)

function unit:targetUpdateBuffAnchor(self, buffName, index, numDebuffs, anchorIndex, size, offsetX, offsetY, mirrorVertically)
	local point, relativePoint
	local startY, auraOffsetY
	if ( mirrorVertically ) then
		point = "BOTTOM"
		relativePoint = "TOP"
		startY = -8
		offsetY = -offsetY
		auraOffsetY = -AURA_OFFSET_Y
	else
		point = "TOP"
		relativePoint="BOTTOM"
		startY = AURA_START_Y
		auraOffsetY = AURA_OFFSET_Y
	end
	 
	local buff = _G[buffName..index]
	if ( index == 1 ) then
		if ( UnitIsFriend("player", self.unit) or numDebuffs == 0 ) then
			buff:SetPoint(point.."LEFT", self, relativePoint.."LEFT", AURA_START_X, startY)		   
		else
			buff:SetPoint(point.."LEFT", self.debuffs, relativePoint.."LEFT", 0, -offsetY)
		end
		self.buffs:SetPoint(point.."LEFT", buff, point.."LEFT", 0, 0)
		self.buffs:SetPoint(relativePoint.."LEFT", buff, relativePoint.."LEFT", 0, -auraOffsetY)
		self.spellbarAnchor = buff
	  elseif ( anchorIndex ~= (index-1) ) then
		buff:SetPoint(point.."LEFT", _G[buffName..anchorIndex], relativePoint.."LEFT", 0, -offsetY)
		self.buffs:SetPoint(relativePoint.."LEFT", buff, relativePoint.."LEFT", 0, -auraOffsetY)
		self.spellbarAnchor = buff
	else
		buff:SetPoint(point.."LEFT", _G[buffName..anchorIndex], point.."RIGHT", offsetX, 0)
	end
  	buff:SetWidth(size)
  	buff:SetHeight(size)
end

local function unit_targetUpdateBuffAnchor(self, buffName, index, numDebuffs, anchorIndex, size, offsetX, offsetY, mirrorVertically)
unit:targetUpdateBuffAnchor(self, buffName, index, numDebuffs, anchorIndex, size, offsetX, offsetY, mirrorVertically)
end
hooksecurefunc("TargetFrame_UpdateBuffAnchor", unit_targetUpdateBuffAnchor)

function unit:targetUpdateDebuffAnchor(self, debuffName, index, numBuffs, anchorIndex, size, offsetX, offsetY, mirrorVertically)
	local buff = _G[debuffName..index];
	local isFriend = UnitIsFriend("player", self.unit);
	 
	local point, relativePoint;
	local startY, auraOffsetY;
	if ( mirrorVertically ) then
		point = "BOTTOM";
		relativePoint = "TOP";
		startY = -8;
		offsetY = - offsetY;
		auraOffsetY = -AURA_OFFSET_Y;
	else
		point = "TOP";
		relativePoint="BOTTOM";
		startY = AURA_START_Y;
		auraOffsetY = AURA_OFFSET_Y;
	end
	 
	if ( index == 1 ) then
		if ( isFriend and numBuffs > 0 ) then
			buff:SetPoint(point.."LEFT", self.buffs, relativePoint.."LEFT", 0, -offsetY);
		else
			buff:SetPoint(point.."LEFT", self, relativePoint.."LEFT", AURA_START_X, startY);
		end
		self.debuffs:SetPoint(point.."LEFT", buff, point.."LEFT", 0, 0);
		self.debuffs:SetPoint(relativePoint.."LEFT", buff, relativePoint.."LEFT", 0, -auraOffsetY);
		if ( ( isFriend ) or ( not isFriend and numBuffs == 0) ) then
			self.spellbarAnchor = buff;
		end
	elseif ( anchorIndex ~= (index-1) ) then
		buff:SetPoint(point.."LEFT", _G[debuffName..anchorIndex], relativePoint.."LEFT", 0, -offsetY);
		self.debuffs:SetPoint(relativePoint.."LEFT", buff, relativePoint.."LEFT", 0, -auraOffsetY);
		if ( ( isFriend ) or ( not isFriend and numBuffs == 0) ) then
			self.spellbarAnchor = buff;
		end
	else
		buff:SetPoint(point.."LEFT", _G[debuffName..(index-1)], point.."RIGHT", offsetX, 0);
	end
 
	buff:SetWidth(size);
	buff:SetHeight(size);
	local debuffFrame =_G[debuffName..index.."Border"];
	debuffFrame:SetWidth(size+2);
	debuffFrame:SetHeight(size+2);
end

local function unit_targetUpdateDebuffAnchor(self, debuffName, index, numBuffs, anchorIndex, size, offsetX, offsetY, mirrorVertically)
unit:targetUpdateDebuffAnchor(self, debuffName, index, numBuffs, anchorIndex, size, offsetX, offsetY, mirrorVertically)
end
hooksecurefunc("TargetFrame_UpdateDebuffAnchor", unit_targetUpdateDebuffAnchor)
hooksecurefunc("TargetFrame_UpdateAuras", function(s)
	for i = 1, MAX_TARGET_BUFFS do
			_, _, ic, _, dT = UnitBuff(s.unit, i)
			if(ic and (not s.maxBuffs or i<=s.maxBuffs)) then
					fS=_G[s:GetName()..'Buff'..i..'Stealable']
					if(UnitIsEnemy(PlayerFrame.unit, s.unit) and dT=='Magic') then
							fS:Show()
					else
							fS:Hide()
					end
			end
	end
end)
end)